
Redmine - Feature #5037

Role-based issue custom field visibility

2010-03-10 16:56 - Dario Laera

Status: Closed Start date: 2010-03-10

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues permissions Estimated time: 0.00 hour

Target version: 2.4.0   

Resolution: Fixed   

Description

It would be nice to define some kind of view permission for fields in issues. For example, when you define a new custom field you

should define also wich role can view this field.

The implementation of #337 should open the way for implementing this feature too.

Related issues:

Related to Redmine - Feature #5011: Limit Visible Issue Fields Based on Permi... Closed 2010-03-08

Related to Redmine - Feature #12005: Mightful workflow field enhancement: hide New

Related to Redmine - Feature #14162: Hidden Fields - Role Based Closed

Related to Redmine - Defect #17096: Issue emails cannot be threaded by some m... Closed

Related to Redmine - Feature #23997: Per role visibility settings for version... Closed

Related to Redmine - Patch #29160: Remove unused and broken method CustomFiel... Closed

Has duplicate Redmine - Feature #8162: Issue custom field visibility per work... Closed 2011-04-15

Has duplicate Redmine - Feature #3976: Hide custom fields from certain roles Closed 2009-10-06

Associated revisions

Revision 12012 - 2013-07-13 11:20 - Jean-Philippe Lang

Role-based issue custom field visibility (#5037).

Revision 12041 - 2013-07-24 20:18 - Jean-Philippe Lang

Fixed that displaying time entries with custom field column raises an error (#5037).

History

#1 - 2010-03-12 17:04 - Jean-Philippe Lang

- Subject changed from Role-based field visibility to Role-based custom field visibility

#2 - 2010-03-30 15:59 - Gints Murāns

+1 For role based custom fields. This is important, because there is information we as developers don't want to share with everybody else. For

example organization heads are not interested in seeing information about technical aspect of the issue?

#3 - 2011-05-06 19:49 - pasquale [:dedalus]

+1

#4 - 2011-05-08 04:14 - Terence Mill

particial dupe of, covered by #8050

#5 - 2011-11-30 11:52 - Panagiotis Korros

+1

#6 - 2012-08-20 12:24 - Moni Ghaoui

+1

#7 - 2012-11-20 00:05 - Terence Mill

related (dupe) of Mightful workflow field enhancement: hide #12005
#8 - 2013-01-12 18:39 - Daniel Felix

- Status changed from New to Closed

- Resolution set to Duplicate

Well I'm closing this, even if #12005 isn't implemented now. But #12005 will resolve exact this request after implementation!

Anyway it's kind of duplicate, even if it was an earlier entry than #12005.

#9 - 2013-05-28 09:56 - Ernesto Baschny

+1 on this, would be a nice improvement, and not overly complex.

#10 - 2013-05-28 09:57 - Ernesto Baschny

Should not be restricted to "custom fields" of course, but to all fields of an issue.

#11 - 2013-05-28 10:00 - Jean-Philippe Lang

- Status changed from Closed to New

- Assignee set to Jean-Philippe Lang

- Target version set to 2.4.0

#12 - 2013-05-28 10:18 - David Robinson

+1

Being able to "hide" certain fields (including not custom fields) for certain roles would be much appreciated.

Also mail updates, reports (pdf) and feeds should not carry hidden fields for the roles for which they have been hidden.

#13 - 2013-05-28 10:57 - VD DV

++++1 for planning this feature for next version. Great!!!

#14 - 2013-05-28 11:01 - Jean-Philippe Lang

David Robinson wrote:

Being able to "hide" certain fields (including not custom fields) for certain roles would be much appreciated.

 Well, this feature planned for 2.4.0 is about custom fields only. Being able to hide some standard fields would be a bit trickier and might be added

later, sorry.

#15 - 2013-05-28 11:09 - David Robinson

Jean-Philippe Lang wrote:

David Robinson wrote:

Being able to "hide" certain fields (including not custom fields) for certain roles would be much appreciated.

 Well, this feature planned for 2.4.0 is about custom fields only. Being able to hide some standard fields would be a bit trickier and might be

added later, sorry.

 OK, Should I create a new feature request for it then?

#16 - 2013-05-28 11:11 - Jean-Philippe Lang

David Robinson wrote:

OK, Should I create a new feature request for it then?

 Sure, and thanks for the feedback!

#17 - 2013-05-28 11:23 - Jean-Philippe Lang

Here are some details about the possible implementation of custom fields visibility:

update the issue custom field form in order to select roles that can see the field
update the issue view (HTML, PDF, API) to hide hidden custom fields, including in the issue history (custom fields changes)

update the issue form to exclude hidden custom fields

completely exclude custom fields from the issue list (columns/filters) if they are not visible by the user on any projects

update the issue list (HTML, PDF, CSV, API) to hide hidden custom fields values per row (on the cross-project list, the user might be able to see

custom fields for some projects but not for some other projects, depending on his roles on these projects)

when filtering or grouping the issue list by a custom field, exclude issues for which the custom is not visible

same thing for the time entries list (where issue custom fields can be displayed/filtered)

update the search engine so that it doesn't look up in searchable custom fields that are not visible

update the email notification system so that each user receives an email with only visible custom field (need to change message-ids since

multiple emails might now be sent for the same event)

when updating an issue by just changing custom fields values, don't notify users that can't see these custom fields

Please let me know if I'm missing something.

#18 - 2013-05-28 11:34 - Ernesto Baschny

Jean-Philippe: maybe also consider Custom Queries:

don't offer the custom fields that are hidden in "custom queries" (queries/new) "Add filter" option

hide Custom Queries which include filtering by some custom field which is hidden

I wonder if it isn't worth to also consider the "regular fields" at the same time, because you will have to touch all those different areas anyway. Or at

least prepare an API for it, to make it easier to later hide "regular fields" (maybe someone could then write a plugin to do so).

From the regular fields there are some "special ones" which shouldn't be hideable, i.e. "Status", "Tracker", "Parent Task" and "Subject".

#19 - 2013-05-28 17:18 - Toshi MARUYAMA

- Resolution deleted (Duplicate)

#20 - 2013-06-27 21:22 - Александр Александрук

+1

It will be very useful feature! Look forward to!

Jean-Philippe Lang You're doing a great job, thank you!

#21 - 2013-07-13 11:32 - Jean-Philippe Lang

- Subject changed from Role-based custom field visibility to Role-based issue custom field visibility

- Status changed from New to Closed

- Resolution set to Fixed

Feature added in r12013. You can now limit the visibility issue custom field to certain roles.

Ernesto Baschny wrote:

don't offer the custom fields that are hidden in "custom queries" (queries/new) "Add filter" option

 Done

hide Custom Queries which include filtering by some custom field which is hidden

 That would involve too much logic for filtering custom queries. Instead, custom queries can now be made visible to certain roles only (#1019 added for

2.4.0). A user that would be able to display a custom query with fields that are not visible to him wouldn't see them anyway. Queries always take care

to show visibile fields only.

#22 - 2013-07-13 14:33 - Terence Mill

This is great Jean! Tx for this.

#23 - 2013-07-15 10:50 - Ernesto Baschny

Thanks Jean!

The correct revision where this was added is r12012.

Still feature #12005 (having the same feature available for standard fields as well) is still very much desired. :)

#24 - 2013-07-22 23:22 - Etienne Massip

- Status changed from Closed to Reopened
500 when trying to add a spent time custom field to spent time report:

ActionView::Template::Error (undefined method `visible_by?' for #<TimeEntryCustomField:0x3e7bb50>):

    19: <tbody>

    20: <% entries.each do |entry| -%>

    21:   <tr class="time-entry <%= cycle("odd", "even") %> hascontextmenu">

    22:     <td class="checkbox hide-when-print"><%= check_box_tag("ids[]", entry.id, false, :id => nil) %></t

d>

    23:     <%= raw @query.inline_columns.map {|column| "<td class=\"#{column.css_classes}\">#{column_content(

column, entry)}</td>"}.join %>

    24:     <td align="center">

    25:     <% if entry.editable_by?(User.current) -%>

  app/models/query.rb:84:in `value'

  app/helpers/queries_helper.rb:84:in `column_content'

  app/views/timelog/_list.html.erb:22:in `block (3 levels) in _app_views_timelog__list_html_erb__1016642981_38

612940'

  app/views/timelog/_list.html.erb:22:in `map'

  app/views/timelog/_list.html.erb:22:in `block (2 levels) in _app_views_timelog__list_html_erb__1016642981_38

612940'

  app/views/timelog/_list.html.erb:19:in `each'

  app/views/timelog/_list.html.erb:19:in `block in _app_views_timelog__list_html_erb__1016642981_38612940'

  app/views/timelog/_list.html.erb:1:in `_app_views_timelog__list_html_erb__1016642981_38612940'

  app/views/timelog/index.html.erb:20:in `_app_views_timelog_index_html_erb___932575742_45051756'

  app/controllers/timelog_controller.rb:64:in `block (2 levels) in index'

  app/controllers/timelog_controller.rb:51:in `index'

 CustomField#visible_by? seems to be implemented in IssueCustomField only, did you mean to implement a default one in CustomField?

#25 - 2013-07-24 20:18 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Etienne Massip wrote:

CustomField#visible_by? seems to be implemented in IssueCustomField only, did you mean to implement a default one in CustomField?

 Thanks for pointing this out, it's fixed in r12041.

#26 - 2013-07-30 11:22 - Vimal Joseph

Thanks for this feature. When can we expect this in a stable release?

#27 - 2013-08-07 02:17 - Toshi MARUYAMA

- Related to Feature #3976: Hide custom fields from certain roles added

#28 - 2013-08-07 09:21 - Toshi MARUYAMA

- Related to deleted (Feature #3976: Hide custom fields from certain roles)

#29 - 2013-08-07 09:22 - Toshi MARUYAMA

- Has duplicate Feature #3976: Hide custom fields from certain roles added

#30 - 2013-09-26 12:54 - Sebastian Sp

Hello, is it possible to add this feature to release 2.3.4, as it would be very very nice for our redmine installations.

Best regards,

Sebastian

#31 - 2013-11-13 09:58 - Christoph Klesser

+1

Sebastian Spill wrote:

Hello, is it possible to add this feature to release 2.3.4, as it would be very very nice for our redmine installations.

Best regards,

Sebastian
#32 - 2013-11-13 11:05 - Tobias Fischer

dude, read the ticket! It's planned for the next version 2.4.0!

2.3.x releases only contain bugfixes and never any new features...

#33 - 2013-11-18 20:39 - Sebastian Sp

Hello,

thanks a lot for quick release! I found a bug regarding this new feature:

When you add custom fields with option "required", the role-based feature does not work correctly. The fields are not displayed, but the validation

routine makes the ticket unsaveable.

Regards,

Sebastian

#34 - 2013-11-19 20:06 - Jean-Philippe Lang

Sebastian Spill wrote:

When you add custom fields with option "required", the role-based feature does not work correctly. The fields are not displayed, but the

validation routine makes the ticket unsaveable.

 Please, open a bug report.

#35 - 2013-12-02 06:15 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

Sebastian Spill wrote:

When you add custom fields with option "required", the role-based feature does not work correctly. The fields are not displayed, but the

validation routine makes the ticket unsaveable.

 Please, open a bug report.

 FTR: #15408

#36 - 2014-02-03 16:03 - Stefan T. Oertel

Hi there,

is there a chance to have the feature also for non-issue related custom fields, like "Spent time"? Would be very useful.

Thanks,

Stefan

#37 - 2014-07-17 08:21 - Juozapis Juozapauskiksi

- File 2014-07-17 09_13_13-Workflow.png added

Hi I cannot see any visibility controls. See attached file.

Sorry looked in wrong place..

#38 - 2015-06-12 08:30 - Toshi MARUYAMA

- Related to Defect #17096: Issue emails cannot be threaded by some mailers due to inconsistent Message-ID and References field added

#39 - 2016-11-02 04:00 - Toshi MARUYAMA

- Related to Feature #23997: Per role visibility settings for version custom fields added

#40 - 2018-06-30 08:06 - Go MAEDA

- Related to Patch #29160: Remove unused and broken method CustomField.visibility_condition added

Files
